Description

Currently (core:develop, discovery:develop) provisioning a discovered host isn't possible. The `import_facts` method assumes there

are two methods defined, enable_orchestration! and skip_orchestration! which do not exist for Host::Discovered.

This causes Foreman to throw the following error "undefined method `enable_orchestration!' for

#<Host::Discovered:0x005623782265b8>". This is also true when importing facts for a host with :unattended => false

Host::Discovered doesn't need the Orchestration module for anything, however `import_facts` assumes it's there. This should involve

two fixes:

1: in discovery, so that it can skip those calls (mocking them or something).

2: in core, so that import_facts doesn't have to rely on anything but Host::Base APIs. It should "know less", and let Host::Managed do

these things (enable/skip orchestration) perhaps, as that's where it matters.

The code that causes this error will go in 1.12.1 

https://github.com/theforeman/foreman/pull/3574/files#diff-07cbb99bfdb4bed86ad02486bb5adde2R174 so we should hurry up and

release a version that fixes the problem. http://projects.theforeman.org/issues/15306

Related issues:

Related to Foreman - Bug #15306: Orchestration does not roll back queued acti... Closed 06/06/2016

Related to Foreman - Bug #17118: Error pushing facts to foreman Duplicate 10/27/2016

Associated revisions

Revision 8cf057c8 - 07/12/2016 08:08 AM - Daniel Lobato Garcia

Fixes #15644 - Move enable/skip_orchestration to Host::Managed

skip_orchestration and enable_orchestration were called in Host::Base

when importing facts. These two methods could not be called there

because they come from the Orchestration mixin which Host::Base does not

have. This blocked importing facts for a Host::Discovered or a Host::Base.

To test this, I've moved the tests that import the facts to a separate

test class just for Host::Base. Notice I've moved a few other tests

which also belong there. There are probably more, but I didn't want to

make this more complicated.

Lastly, Nic::Managed called lookup_value_match on save, so importing

facts didn't work for Host::Base as that method wasn't there either, so

I moved it. Same logic applies to 'setup_clone'.

History

#1 - 07/11/2016 10:13 AM - Daniel Lobato Garcia

- Related to Bug #15306: Orchestration does not roll back queued actions if DB error occurs added

#2 - 07/11/2016 10:21 AM - Dominic Cleal
https://github.com/theforeman/foreman/pull/3574/files#diff-07cbb99bfdb4bed86ad02486bb5adde2R174
http://projects.theforeman.org/issues/15306


This is a bug in Foreman if Host::Base assumes a Host::Managed (Orchestration) method exists.

#3 - 07/11/2016 10:55 AM - Daniel Lobato Garcia

- Project changed from Discovery to Foreman

- Category changed from Discovery plugin to Orchestration

Moving to Foreman then

#4 - 07/11/2016 11:01 AM - Dominic Cleal

- translation missing: en.field_release set to 161

#6 - 07/11/2016 12:52 PM - The Foreman Bot

- Status changed from New to Ready For Testing

- Assignee set to Daniel Lobato Garcia

- Pull request https://github.com/theforeman/foreman/pull/3637 added

#7 - 07/12/2016 08:11 AM - Dominic Cleal

- translation missing: en.field_release changed from 161 to 160

#8 - 07/12/2016 09:02 AM - Daniel Lobato Garcia

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset 8cf057c84f11598d92918a0b747cf49903822e69.

#9 - 10/27/2016 03:11 AM - Felix Barbeira

- Related to Bug #17118: Error pushing facts to foreman added

#10 - 11/04/2016 12:46 PM - Daniel Lobato Garcia

- Target version set to 1.5.2

Powered by TCPDF (www.tcpdf.org)

05/18/2024 2/2

https://projects.theforeman.org/projects/foreman/repository/foreman/revisions/8cf057c84f11598d92918a0b747cf49903822e69
http://www.tcpdf.org

